export interface TreeviewSelection {
    checkedItems: TreeviewItem[];
    uncheckedItems: TreeviewItem[];
}
export interface TreeItem {
    id?: string;
    parentId?: string;
    text: string;
    value: any;
    level?: number;
    disabled?: boolean;
    isLast?: boolean;
    checked?: boolean;
    collapsed?: boolean;
    children?: TreeItem[];
}
export declare class TreeviewItem {
    private internalDisabled;
    private internalChecked;
    private internalCollapsed;
    private internalIsLast;
    private internalChildren;
    id: string;
    parentId: string;
    text: string;
    value: any;
    level: number;
    constructor(item: TreeItem, autoCorrectChecked?: boolean);
    checked: boolean;
    isLast: boolean;
    readonly indeterminate: boolean;
    setCheckedRecursive(value: boolean): void;
    disabled: boolean;
    collapsed: boolean;
    setCollapsedRecursive(value: boolean): void;
    children: TreeviewItem[];
    getSelection(): TreeviewSelection;
    correctChecked(): void;
    private getCorrectChecked;
}
